
//+------------------------------------------------------------------+

#property  copyright "jpkfox"
#property  link      "http://www.strategybuilderfx.com/forums/showthread.php?t=15274&page=1&pp=8"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 7
#property  indicator_color1  LimeGreen
#property  indicator_color2  Red
#property  indicator_color3  Aqua
#property  indicator_color4  DodgerBlue
#property  indicator_color5  DodgerBlue
#property  indicator_color6  Yellow
#property  indicator_color7  OrangeRed
//---- indicator parameters
extern int EMAPeriod=34;
extern int EMAPeriod1=34;
extern int SignalPeriod=34;
extern int SignalPeriod1=34;
extern int SignalMode  =1;
int EMAPeriod2=34;
extern double AngleMini=0.2;
extern int StartEMAShift=6;
extern int EndEMAShift=0;

//---- indicator buffers
double UpBuffer[];
double DownBuffer[];
double AngleBuffer[];
double SignalBuffer[];
double LevelUpBuffer[];
double LevelDownBuffer[];
double SignalBuffer1[];
double val[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(8);
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,1);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);

//---- 5 indicator buffers mapping
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DownBuffer);
   SetIndexBuffer(2,AngleBuffer);
   SetIndexBuffer(3,LevelUpBuffer);
   SetIndexBuffer(4,LevelDownBuffer);
   SetIndexBuffer(5,SignalBuffer);
   SetIndexBuffer(6,SignalBuffer1);
   SetIndexBuffer(7,val);
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("EMAAngleZero("+EMAPeriod+","+AngleMini+","+StartEMAShift+","+EndEMAShift+")");
//---- initialization done
   return(0);
}
//+------------------------------------------------------------------+
//| The angle for EMA                                                |
//+------------------------------------------------------------------+
int start()
{
   double R0,R1=0,R5=0,RC=0,RH=0,RAvg=0;
   string Infos = "";
   int i=0;
   R0 =  (iHigh(NULL,PERIOD_D1,0)-iLow(NULL,PERIOD_D1,0))/Point;
   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   for(i=1;i<=5;i++)
   R5    =    R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/5*Point;
   for(i=1;i<=20;i++)
   RC   =    (RC +  (iClose(NULL,0,i)-iLow(NULL,0,i))/20)/Point;
   for(i=1;i<=20;i++)
   RH   =    (RH +  (iHigh(NULL,0,i)-iLow(NULL,0,i))/20)/Point;
   double fEndMA, fStartMA,fEndMAP, fStartMAP;
   double fAngle,fAngleP, mFactor, dFactor;
   int nLimit,k;
   int nCountedBars;
   int ShiftDif;
 
   if(EndEMAShift >= StartEMAShift)
   {
      Print("Error: EndEMAShift >= StartEMAShift");
      StartEMAShift = 6;
      EndEMAShift = 0;      
   }  
         
   nCountedBars = IndicatorCounted();
//---- check for possible errors
   if(nCountedBars<0) 
      return(-1);
//---- last counted bar will be recounted
   if(nCountedBars>0) 
      nCountedBars--;
   nLimit = Bars-nCountedBars;
   dFactor = 3.14159/180.0;
   mFactor = /*10000.0;1/Point;*/iATR(NULL,0,14,i)/MathPow(Point,2);
  /* if (Symbol() == "USDJPY") mFactor = 100.0;*/
   ShiftDif = StartEMAShift-EndEMAShift;
   mFactor /= ShiftDif; 
//---- main loop
   for(i=0; i<nLimit; i++)
   {
      fEndMA=iMA(NULL,0,EMAPeriod,0,MODE_EMA,PRICE_MEDIAN,i+EndEMAShift);
      fStartMA=iMA(NULL,0,EMAPeriod1,0,MODE_EMA,PRICE_MEDIAN,i+StartEMAShift);
      fEndMAP=iMA(NULL,0,EMAPeriod,0,MODE_EMA,PRICE_MEDIAN,i+EndEMAShift);
      fStartMAP=iMA(NULL,0,EMAPeriod1,0,MODE_EMA,PRICE_MEDIAN,i+StartEMAShift);
      k=/*iMA(NULL,0,EMAPeriod2,0,MODE_EMA,PRICE_LOW,i+EndEMAShift)/Point;(Close[i]-Close[i+1])/Point;*/mFactor;
      // 10000.0 : Multiply by 10000 so that the fAngle is not too small
      // for the indicator Window.
      
      fAngle  =  k * (fEndMA  - fStartMA);
      fAngleP =  k * (fEndMAP - fStartMAP);
      
     if (fAngle< AngleMini && fAngle >= 0) fAngle = AngleMini/2;
     if (fAngle< AngleMini && fAngle >= 0) fAngle =MathMax(fAngleP,fAngle);
     
     if (fAngle>-AngleMini && fAngle <= 0) fAngle = -AngleMini/2;
     if (fAngle>-AngleMini && fAngle <= 0) fAngle = MathMin(fAngleP,fAngle);
     
     
      
      if(fAngle > fAngleP )UpBuffer[i] = fAngle;
       
      if(fAngle == fAngleP && fAngle >AngleMini) UpBuffer[i] = fAngleP;
      else
      if(fAngleP - fAngle < fAngleP*0.05 && fAngle >AngleMini) UpBuffer[i] = fAngle;
      else 
      if(fAngle < fAngleP )DownBuffer[i] = fAngle;
      if(fAngle == fAngleP && fAngle <-AngleMini)DownBuffer[i] = fAngle;
       AngleBuffer[i]     =  fAngle; 
       /*SignalBuffer[i]     =  AngleBuffer[i+1];*/
       LevelUpBuffer[i]  = AngleMini;
       LevelDownBuffer[i]=-AngleMini;
       }
       for(i=0; i<nLimit; i++)
       {
        val[i] =AngleBuffer[i-2];
       SignalBuffer[i]  = iMAOnArray(AngleBuffer,Bars,SignalPeriod,0,SignalMode,i);
       }
       for(i=0; i<nLimit; i++)
       {
       if (fAngle >0)
       SignalBuffer1[i]  = MathMax(AngleBuffer[i],SignalBuffer[i]);
       }
   return(0);
  }
   